/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.54 Revision 1.132
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.54 2009/12/06 09:34:36 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.132 2012/06/07 15:36:49 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
12case ${EAPI} in
13 2|3|4) : ;;
14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit base eutils flag-o-matic multilib toolchain-funcs versionator
16 18
17IUSE="${IUSE} debug pch" 19if [[ ${PV} == *9999* ]]; then
18RDEPEND=" 20 QT4_BUILD_TYPE="live"
19 !<x11-libs/qt-assistant-${PV} 21 inherit git-2
20 !>x11-libs/qt-assistant-${PV}-r9999 22else
21 !<x11-libs/qt-core-${PV} 23 QT4_BUILD_TYPE="release"
22 !>x11-libs/qt-core-${PV}-r9999 24fi
23 !<x11-libs/qt-dbus-${PV} 25
24 !>x11-libs/qt-dbus-${PV}-r9999 26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
25 !<x11-libs/qt-demo-${PV} 27LICENSE="|| ( LGPL-2.1 GPL-3 )"
26 !>x11-libs/qt-demo-${PV}-r9999 28
27 !<x11-libs/qt-gui-${PV}
28 !>x11-libs/qt-gui-${PV}-r9999
29 !<x11-libs/qt-opengl-${PV}
30 !>x11-libs/qt-opengl-${PV}-r9999
31 !<x11-libs/qt-phonon-${PV}
32 !>x11-libs/qt-phonon-${PV}-r9999
33 !<x11-libs/qt-qt3support-${PV}
34 !>x11-libs/qt-qt3support-${PV}-r9999
35 !<x11-libs/qt-script-${PV}
36 !>x11-libs/qt-script-${PV}-r9999
37 !<x11-libs/qt-sql-${PV}
38 !>x11-libs/qt-sql-${PV}-r9999
39 !<x11-libs/qt-svg-${PV}
40 !>x11-libs/qt-svg-${PV}-r9999
41 !<x11-libs/qt-test-${PV}
42 !>x11-libs/qt-test-${PV}-r9999
43 !<x11-libs/qt-webkit-${PV}
44 !>x11-libs/qt-webkit-${PV}-r9999
45 !<x11-libs/qt-xmlpatterns-${PV}
46 !>x11-libs/qt-xmlpatterns-${PV}-r9999
47"
48case "${PV}" in
49 4.?.?_rc* | 4.?.?_beta* )
50 SRCTYPE="${SRCTYPE:-opensource-src}"
51 MY_PV="${PV/_/-}" 29MY_PV=${PV/_/-}
30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH="${PV%.9999}"
52 ;; 37 ;;
53 *) 38 release)
54 SRCTYPE="${SRCTYPE:-opensource-src}" 39 if version_is_at_least 4.8.1; then
55 MY_PV="${PV}" 40 SRC_URI="http://releases.qt-project.org/qt4/source/${MY_P}.tar.gz"
41 else
42 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
43 fi
56 ;; 44 ;;
57esac 45esac
58 46
59if version_is_at_least 4.5.99999999 ${PV} ; then 47IUSE="aqua debug pch"
60 MY_P="qt-everywhere-${SRCTYPE}-${MY_PV}" 48if [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]]; then
61else 49 IUSE+=" +exceptions"
62 MY_P="qt-x11-${SRCTYPE}-${MY_PV}"
63fi 50fi
51if version_is_at_least 4.8; then
52 IUSE+=" c++0x qpa"
53fi
54
55DEPEND="virtual/pkgconfig"
56if [[ ${QT4_BUILD_TYPE} == live ]]; then
57 DEPEND+=" dev-lang/perl"
58fi
59
60RDEPEND="
61 !<x11-libs/qt-assistant-${PV}:4
62 !>x11-libs/qt-assistant-${PV}-r9999:4
63 !<x11-libs/qt-bearer-${PV}:4
64 !>x11-libs/qt-bearer-${PV}-r9999:4
65 !<x11-libs/qt-core-${PV}:4
66 !>x11-libs/qt-core-${PV}-r9999:4
67 !<x11-libs/qt-dbus-${PV}:4
68 !>x11-libs/qt-dbus-${PV}-r9999:4
69 !<x11-libs/qt-declarative-${PV}:4
70 !>x11-libs/qt-declarative-${PV}-r9999:4
71 !<x11-libs/qt-demo-${PV}:4
72 !>x11-libs/qt-demo-${PV}-r9999:4
73 !<x11-libs/qt-gui-${PV}:4
74 !>x11-libs/qt-gui-${PV}-r9999:4
75 !<x11-libs/qt-multimedia-${PV}:4
76 !>x11-libs/qt-multimedia-${PV}-r9999:4
77 !<x11-libs/qt-opengl-${PV}:4
78 !>x11-libs/qt-opengl-${PV}-r9999:4
79 !<x11-libs/qt-openvg-${PV}:4
80 !>x11-libs/qt-openvg-${PV}-r9999:4
81 !<x11-libs/qt-phonon-${PV}:4
82 !>x11-libs/qt-phonon-${PV}-r9999:4
83 !<x11-libs/qt-qt3support-${PV}:4
84 !>x11-libs/qt-qt3support-${PV}-r9999:4
85 !<x11-libs/qt-script-${PV}:4
86 !>x11-libs/qt-script-${PV}-r9999:4
87 !<x11-libs/qt-sql-${PV}:4
88 !>x11-libs/qt-sql-${PV}-r9999:4
89 !<x11-libs/qt-svg-${PV}:4
90 !>x11-libs/qt-svg-${PV}-r9999:4
91 !<x11-libs/qt-test-${PV}:4
92 !>x11-libs/qt-test-${PV}-r9999:4
93 !<x11-libs/qt-webkit-${PV}:4
94 !>x11-libs/qt-webkit-${PV}-r9999:4
95 !<x11-libs/qt-xmlpatterns-${PV}:4
96 !>x11-libs/qt-xmlpatterns-${PV}-r9999:4
97"
98
64S=${WORKDIR}/${MY_P} 99S=${WORKDIR}/${MY_P}
65 100
66HOMEPAGE="http://qt.nokia.com/"
67if version_is_at_least 4.5.3 ${PV} ; then
68 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
69else
70 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.bz2"
71fi
72
73case "${PV}" in
74 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
75 *) ;;
76esac
77
78if version_is_at_least 4.5 ${PV} ; then
79 LICENSE="|| ( LGPL-2.1 GPL-3 )"
80fi
81
82# @FUNCTION: qt4-build_pkg_setup 101# @FUNCTION: qt4-build_pkg_setup
83# @DESCRIPTION: 102# @DESCRIPTION:
84# Sets up installation directories, PLATFORM, PATH, and LD_LIBRARY_PATH 103# Sets up PATH and LD_LIBRARY_PATH.
85qt4-build_pkg_setup() { 104qt4-build_pkg_setup() {
86 # EAPI=2 ebuilds set use-deps, others need this: 105 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
87 if [[ $EAPI != 2 ]]; then 106
88 # Make sure debug setting corresponds with qt-core (bug 258512) 107 # Protect users by not allowing downgrades between releases
89 if [[ $PN != "qt-core" ]]; then 108 # Downgrading revisions within the same release should be allowed
90 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 109 if has_version ">${CATEGORY}/${P}-r9999:4"; then
91 ~x11-libs/qt-core-${PV} debug" 110 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
111 eerror
112 eerror "Sanity check to keep you from breaking your system:"
113 eerror " Downgrading Qt is completely unsupported and will break your system!"
114 eerror
115 die "aborting to save your system"
116 else
117 ewarn "Downgrading Qt is completely unsupported and will break your system!"
92 fi 118 fi
119 fi
93 120
94 # Check USE requirements 121 if [[ ${PN} == qt-webkit ]]; then
95 qt4-build_check_use 122 eshopts_push -s extglob
123 if is-flagq '-g?(gdb)?([1-9])'; then
124 echo
125 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
126 ewarn "You may experience really long compilation times and/or increased memory usage."
127 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
128 ewarn "For more info check out bug #307861"
129 echo
96 fi 130 fi
131 eshopts_pop
132 fi
97 133
98 PATH="${S}/bin:${PATH}" 134 PATH="${S}/bin${PATH:+:}${PATH}"
135 if [[ ${CHOST} != *-darwin* ]]; then
99 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 136 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
137 else
138 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
139 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
140 # platform detection. Note: needs to come before any directories to
141 # avoid extract failure.
142 [[ ${CHOST} == *-apple-darwin* ]] && \
143 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
144 ${QT4_EXTRACT_DIRECTORIES}"
145 fi
100 146
101 if ! version_is_at_least 4.1 $(gcc-version) ; then 147 if ! version_is_at_least 4.1 $(gcc-version); then
102 ewarn "Using a GCC version lower than 4.1 is not supported!" 148 ewarn "Using a GCC version lower than 4.1 is not supported."
103 echo
104 ebeep 3
105 fi 149 fi
106
107 if [[ "${P}" == "qt-core-4.6.0_rc1" ]]; then
108 ewarn
109 ewarn "Binary compatibility broke between 4.6.0_beta1 and 4.6.0_rc1."
110 ewarn "If you are upgrading from 4.6.0_beta1, you'll have to"
111 ewarn "re-emerge everything that depends on Qt."
112 ewarn "Use the following command:"
113 ewarn
114 ewarn " emerge -av1 \$(for i in \$(qlist -IC x11-libs/qt-);"
115 ewarn " do equery -q d \$i | grep -v 'x11-libs/qt-' |"
116 ewarn " sed \"s/^/=/\"; done)"
117 ewarn
118 ewarn "YOU'VE BEEN WARNED"
119 ewarn
120 ebeep 3
121 fi
122
123} 150}
124 151
125# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 152# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
126# @DESCRIPTION: 153# @DESCRIPTION:
127# Arguments for build_target_directories. Takes the directories, in which the 154# Arguments for build_target_directories. Takes the directories in which the
128# code should be compiled. This is a space-separated list 155# code should be compiled. This is a space-separated list.
129 156
130# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 157# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
131# @DESCRIPTION: 158# @DESCRIPTION:
132# Space separated list including the directories that will be extracted from Qt 159# Space-separated list including the directories that will be extracted from
133# tarball 160# Qt tarball.
134 161
135# @FUNCTION: qt4-build_src_unpack 162# @FUNCTION: qt4-build_src_unpack
136# @DESCRIPTION: 163# @DESCRIPTION:
137# Unpacks the sources 164# Unpacks the sources.
138qt4-build_src_unpack() { 165qt4-build_src_unpack() {
139 setqtenv 166 setqtenv
140 local target targets licenses tar_pkg tar_args 167
141 if version_is_at_least 4.5 ${PV} ; then 168 case ${QT4_BUILD_TYPE} in
142 licenses="LICENSE.GPL3 LICENSE.LGPL" 169 live)
143 else 170 git-2_src_unpack
144 licenses="LICENSE.GPL2 LICENSE.GPL3" 171 ;;
145 fi 172 release)
146 for target in configure ${licenses} projects.pro \ 173 local tarball="${MY_P}.tar.gz" target= targets=
174 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
147 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 175 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
148 ${QT4_EXTRACT_DIRECTORIES}; do 176 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
177 do
149 targets="${targets} ${MY_P}/${target}" 178 targets+="${MY_P}/${target} "
150 done 179 done
151 180
152 tar_pkg=${MY_P}.tar.bz2 181 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
153 tar_args="xjpf" 182 tar -xzf "${DISTDIR}/${tarball}" ${targets}
154 if version_is_at_least 4.5.3 ${PV} ; then 183 eend $? || die "failed to unpack"
155 tar_pkg=${tar_pkg/bz2/gz}
156 tar_args="xzpf"
157 fi
158
159 echo tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
160 tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
161
162 case "${PV}" in
163 4.4.?)
164 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
165 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
166 ;; 184 ;;
167 esac 185 esac
168
169 # Be backwards compatible for now
170 if [[ $EAPI != 2 ]]; then
171 qt4-build_src_prepare
172 fi
173} 186}
174 187
175# @ECLASS-VARIABLE: PATCHES 188# @ECLASS-VARIABLE: PATCHES
189# @DEFAULT_UNSET
176# @DESCRIPTION: 190# @DESCRIPTION:
177# In case you have patches to apply, specify them in PATCHES variable. Make sure 191# PATCHES array variable containing all various patches to be applied.
178# to specify the full path. This variable is necessary for src_prepare phase. 192# This variable is expected to be defined in global scope of ebuild.
179# example: 193# Make sure to specify the full path. This variable is utilised in
180# PATCHES="${FILESDIR}"/mypatch.patch 194# src_unpack/src_prepare phase, based on EAPI.
181# ${FILESDIR}"/mypatch2.patch"
182# 195#
196# @CODE
197# PATCHES=( "${FILESDIR}/mypatch.patch"
198# "${FILESDIR}/patches_folder/" )
199# @CODE
183 200
184# @FUNCTION: qt4-build_src_prepare 201# @FUNCTION: qt4-build_src_prepare
185# @DESCRIPTION: 202# @DESCRIPTION:
186# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 203# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
187# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 204# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
188qt4-build_src_prepare() { 205qt4-build_src_prepare() {
189 setqtenv 206 setqtenv
190 cd "${S}" 207
208 if [[ ${QT4_BUILD_TYPE} == live ]]; then
209 QTDIR="." ./bin/syncqt || die "syncqt failed"
210 fi
211
212 if version_is_at_least 4.7; then
213 # fix libX11 dependency on non X packages
214 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
215 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
216
217 qt_assistant_cleanup
218 fi
219
220 if use aqua; then
221 # provide a proper macx-g++-64
222 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
223
224 sed -e '/^CONFIG/s:app_bundle::' \
225 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
226 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
227 fi
191 228
192 if [[ ${PN} != qt-core ]]; then 229 if [[ ${PN} != qt-core ]]; then
193 skip_qmake_build_patch 230 skip_qmake_build
194 skip_project_generation_patch 231 skip_project_generation
195 symlink_binaries_to_buildtree 232 symlink_binaries_to_buildtree
196 fi 233 fi
197 234
198 # Bug 282984 && Bug 295530 235 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
199 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\n\1:" \ 236 # qmake bus errors with -O2 or -O3 but -O1 works
200 -i configure || die "sed qmake compilers failed" 237 # Bug 373061
201 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX):" \ 238 replace-flags -O[23] -O1
202 -i config.tests/unix/compile.test || die "sed test compilers failed" 239 fi
203 240
204 # Bug 178652 241 # Bug 178652
205 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 242 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
206 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 243 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
207 append-flags -fno-gcse 244 append-flags -fno-gcse
208 fi 245 fi
209 246
247 if use_if_iuse c++0x; then
248 echo
249 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
250 ewarn "this is an official standard, some of the reverse dependencies"
251 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
252 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
253 ewarn "disabled."
254 echo
255 append-flags -std=c++0x
256 fi
257
210 # Unsupported old gcc versions - hardened needs this :( 258 # Unsupported old gcc versions - hardened needs this :(
211 if [[ $(gcc-major-version) -lt "4" ]] ; then 259 if [[ $(gcc-major-version) -lt 4 ]]; then
212 ewarn "Appending -fno-stack-protector to CXXFLAGS" 260 ewarn "Appending -fno-stack-protector to CXXFLAGS"
213 append-cxxflags -fno-stack-protector 261 append-cxxflags -fno-stack-protector
214 # Bug 253127 262 # Bug 253127
215 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 263 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
216 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 264 -i mkspecs/common/g++.conf || die
217 fi 265 fi
218 266
219 # Bug 261632 267 # Bug 261632
220 if use ppc64; then 268 if use ppc64; then
221 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 269 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
222 append-flags -mminimal-toc 270 append-flags -mminimal-toc
223 fi 271 fi
224 272
273 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
274 sed -e "/^SYSTEM_VARIABLES=/i \
275 CC='$(tc-getCC)'\n\
276 CXX='$(tc-getCXX)'\n\
277 CFLAGS='${CFLAGS}'\n\
278 CXXFLAGS='${CXXFLAGS}'\n\
279 LDFLAGS='${LDFLAGS}'\n" \
280 -i configure \
281 || die "sed SYSTEM_VARIABLES failed"
282
283 # Respect CC, CXX, LINK and *FLAGS in config.tests
284 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
285 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
286 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
287 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
288 || die "sed config.tests failed"
289
290 if ! version_is_at_least 4.8; then
291 # Strip predefined CFLAGS from mkspecs (bugs 312689 and 352778)
292 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
293 fi
294
225 # Bug 172219 295 # Bug 172219
296 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
297
298 if [[ ${CHOST} == *-darwin* ]]; then
299 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
300 # crippled (by design) :/
301 local mac_gpp_conf=
302 if [[ -f mkspecs/common/mac-g++.conf ]]; then
303 # qt < 4.8 has mac-g++.conf
304 mac_gpp_conf="mkspecs/common/mac-g++.conf"
305 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
306 # qt >= 4.8 has g++-macx.conf
307 mac_gpp_conf="mkspecs/common/g++-macx.conf"
308 else
309 die "no known conf file for mac found"
310 fi
311 sed \
226 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 312 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
227 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 313 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
228 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 314 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
229 -e "s:X11R6/::" \ 315 -e "s:-arch\s\w*::g" \
230 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 316 -i ${mac_gpp_conf} \
317 || die "sed ${mac_gpp_conf} failed"
231 318
232 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 319 # Fix configure's -arch settings that appear in qmake/Makefile and also
233 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 320 # fix arch handling (automagically duplicates our -arch arg and breaks
234 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 321 # pch). Additionally disable Xarch support.
235 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 322 local mac_gcc_confs="${mac_gpp_conf}"
323 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
324 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
325 fi
326 sed \
327 -e "s:-arch i386::" \
328 -e "s:-arch ppc::" \
329 -e "s:-arch x86_64::" \
330 -e "s:-arch ppc64::" \
331 -e "s:-arch \$i::" \
332 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
333 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
334 -e "s:-Xarch_x86_64::g" \
335 -e "s:-Xarch_ppc64::g" \
336 -i configure ${mac_gcc_confs} \
337 || die "sed -arch/-Xarch failed"
338
339 # On Snow Leopard don't fall back to 10.5 deployment target.
340 if [[ ${CHOST} == *-apple-darwin10 ]]; then
341 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
342 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
343 -i configure ${mac_gpp_conf} \
344 || die "sed deployment target failed"
345 fi
346 fi
347
348 # this one is needed for all systems with a separate -liconv, apart from
349 # Darwin, for which the sources already cater for -liconv
350 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
351 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
352 -i config.tests/unix/iconv/iconv.pro \
353 || die "sed iconv.pro failed"
354 fi
355
356 # we need some patches for Solaris
357 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
358 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
359 # use GCC over SunStudio
360 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
361 # do not flirt with non-Prefix stuff, we're quite possessive
362 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
363 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
236 364
237 base_src_prepare 365 base_src_prepare
238} 366}
239 367
240# @FUNCTION: qt4-build_src_configure 368# @FUNCTION: qt4-build_src_configure
241# @DESCRIPTION: 369# @DESCRIPTION:
242# Default configure phase 370# Default configure phase
243qt4-build_src_configure() { 371qt4-build_src_configure() {
244 setqtenv 372 setqtenv
245 myconf="$(standard_configure_options) ${myconf}"
246 373
247 echo ./configure ${myconf}
248 ./configure ${myconf} || die "./configure failed"
249 myconf=""
250}
251
252# @FUNCTION: qt4-build_src_compile
253# @DESCRIPTION: Actual compile phase
254qt4-build_src_compile() {
255 setqtenv
256 # Be backwards compatible for now
257 if [[ $EAPI != 2 ]]; then
258 qt4-build_src_configure
259 fi
260
261 build_directories "${QT4_TARGET_DIRECTORIES}"
262}
263
264# @FUNCTION: qt4-build_src_install
265# @DESCRIPTION:
266# Perform the actual installation including some library fixes.
267qt4-build_src_install() {
268 setqtenv
269 install_directories "${QT4_TARGET_DIRECTORIES}"
270 install_qconfigs
271 fix_library_files
272}
273
274# @FUNCTION: setqtenv
275setqtenv() {
276 # Set up installation directories
277 QTBASEDIR=/usr/$(get_libdir)/qt4
278 QTPREFIXDIR=/usr
279 QTBINDIR=/usr/bin
280 QTLIBDIR=/usr/$(get_libdir)/qt4
281 QMAKE_LIBDIR_QT=${QTLIBDIR}
282 QTPCDIR=/usr/$(get_libdir)/pkgconfig
283 QTDATADIR=/usr/share/qt4
284 QTDOCDIR=/usr/share/doc/qt-${PV}
285 QTHEADERDIR=/usr/include/qt4
286 QTPLUGINDIR=${QTLIBDIR}/plugins
287 QTSYSCONFDIR=/etc/qt4
288 QTTRANSDIR=${QTDATADIR}/translations
289 QTEXAMPLESDIR=${QTDATADIR}/examples
290 QTDEMOSDIR=${QTDATADIR}/demos
291 QT_INSTALL_PREFIX=/usr/$(get_libdir)/qt4
292 PLATFORM=$(qt_mkspecs_dir)
293
294 unset QMAKESPEC
295}
296
297# @FUNCTION: standard_configure_options
298# @DESCRIPTION:
299# Sets up some standard configure options, like libdir (if necessary), whether
300# debug info is wanted or not.
301standard_configure_options() {
302 local myconf="" 374 local conf="
303 375 -prefix ${QTPREFIXDIR}
304 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 376 -bindir ${QTBINDIR}
305 377 -libdir ${QTLIBDIR}
306 # Disable visibility explicitly if gcc version isn't 4 378 -docdir ${QTDOCDIR}
307 if [[ "$(gcc-major-version)" -lt "4" ]]; then 379 -headerdir ${QTHEADERDIR}
308 myconf="${myconf} -no-reduce-exports" 380 -plugindir ${QTPLUGINDIR}
309 fi 381 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
310 382 -datadir ${QTDATADIR}
311 # precompiled headers doesn't work on hardened, where the flag is masked. 383 -translationdir ${QTTRANSDIR}
312 if use pch; then 384 -sysconfdir ${QTSYSCONFDIR}
313 myconf="${myconf} -pch" 385 -examplesdir ${QTEXAMPLESDIR}
314 else 386 -demosdir ${QTDEMOSDIR}
315 myconf="${myconf} -no-pch" 387 -opensource -confirm-license
316 fi 388 -shared -fast -largefile -stl -verbose
317 389 -nomake examples -nomake demos"
318 if use debug; then
319 myconf="${myconf} -debug -no-separate-debug-info"
320 else
321 myconf="${myconf} -release -no-separate-debug-info"
322 fi
323 390
324 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 391 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
325 # $(tc-arch). Therefore we convert it to supported values. 392 # $(tc-arch). Therefore we convert it to supported values.
326 case "$(tc-arch)" in 393 case "$(tc-arch)" in
327 amd64) myconf="${myconf} -arch x86_64" ;; 394 amd64|x64-*) conf+=" -arch x86_64" ;;
395 ppc-macos) conf+=" -arch ppc" ;;
328 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 396 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
397 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
398 x86-macos) conf+=" -arch x86" ;;
329 x86|x86-*) myconf="${myconf} -arch i386" ;; 399 x86|x86-*) conf+=" -arch i386" ;;
330 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 400 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
331 hppa|sh) myconf="${myconf} -arch generic" ;; 401 hppa|sh) conf+=" -arch generic" ;;
332 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 402 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
333 esac 403 esac
334 404
335 # 4.6: build qt-core with exceptions or qt-xmlpatterns won't build 405 conf+=" -platform $(qt_mkspecs_dir)"
336 local exceptions= 406
337 case "${PV}" in 407 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
338 4.6.*) 408
339 if [[ ${PN} != "qt-core" ]] && [[ ${PN} != "qt-xmlpatterns" ]]; then 409 # debug/release
340 exceptions="-no-exceptions" 410 if use debug; then
411 conf+=" -debug"
412 else
413 conf+=" -release"
414 fi
415 conf+=" -no-separate-debug-info"
416
417 # exceptions USE flag
418 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
419
420 # disable rpath on Qt >= 4.8 (bug 380415)
421 # but leave it enabled on prefix (bug 417169)
422 version_is_at_least 4.8 && use !prefix && conf+=" -no-rpath"
423
424 # precompiled headers don't work on hardened, where the flag is masked
425 conf+=" $(qt_use pch)"
426
427 # -reduce-relocations
428 # This flag seems to introduce major breakage to applications,
429 # mostly to be seen as a core dump with the message "QPixmap: Must
430 # construct a QApplication before a QPaintDevice" on Solaris.
431 # -- Daniel Vergien
432 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
433
434 # this one is needed for all systems with a separate -liconv, apart from
435 # Darwin, for which the sources already cater for -liconv
436 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
437 conf+=" -liconv"
438 fi
439
440 if use_if_iuse glib; then
441 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
442 # avoid the -pthread argument
443 conf+=" ${glibflags//-pthread}"
444 unset glibflags
445 fi
446
447 if use_if_iuse qpa; then
448 echo
449 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
450 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
451 ewarn "disable it before reporting any bugs related to this useflag."
452 echo
453 conf+=" -qpa"
454 fi
455
456 if use aqua; then
457 # On (snow) leopard use the new (frameworked) cocoa code.
458 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
459 conf+=" -cocoa -framework"
460 # We need the source's headers, not the installed ones.
461 conf+=" -I${S}/include"
462 # Add hint for the framework location.
463 conf+=" -F${QTLIBDIR}"
464
465 # We are crazy and build cocoa + qt3support :-)
466 if use qt3support; then
467 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
468 -i configure || die
341 fi 469 fi
342 ;; 470 else
343 *) 471 conf+=" -no-framework"
344 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions" 472 fi
345 ;; 473 else
346 esac 474 # freetype2 include dir is non-standard, thus pass it to configure
475 conf+=" $(pkg-config --cflags-only-I freetype2)"
476 fi
347 477
348 myconf="${myconf} -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
349 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
350 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
351 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
352 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
353 -demosdir ${QTDEMOSDIR} -silent -fast
354 ${exceptions}
355 -reduce-relocations -nomake examples -nomake demos"
356
357 # Make eclass >= 4.5.x ready
358 case "${MY_PV}" in
359 4.5.* | 4.6.* )
360 myconf="${myconf} -opensource"
361 ;;
362 esac
363
364 echo "${myconf}" 478 conf+=" ${myconf}"
479 myconf=
480
481 echo ./configure ${conf}
482 ./configure ${conf} || die "./configure failed"
483
484 prepare_directories ${QT4_TARGET_DIRECTORIES}
365} 485}
486
487# @FUNCTION: qt4-build_src_compile
488# @DESCRIPTION:
489# Actual compile phase
490qt4-build_src_compile() {
491 setqtenv
492
493 build_directories ${QT4_TARGET_DIRECTORIES}
494}
495
496# @FUNCTION: qt4-build_src_test
497# @DESCRIPTION:
498# Runs tests only in target directories.
499qt4-build_src_test() {
500 # QtMultimedia does not have any test suite (bug #332299)
501 [[ ${PN} == qt-multimedia ]] && return
502
503 for dir in ${QT4_TARGET_DIRECTORIES}; do
504 emake -j1 check -C ${dir}
505 done
506}
507
508# @FUNCTION: fix_includes
509# @DESCRIPTION:
510# For MacOS X we need to add some symlinks when frameworks are
511# being used, to avoid complications with some more or less stupid packages.
512fix_includes() {
513 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
514 local frw dest f h rdir
515 # Some packages tend to include <Qt/...>
516 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
517
518 # Fake normal headers when frameworks are installed... eases life later
519 # on, make sure we use relative links though, as some ebuilds assume
520 # these dirs exist in src_install to add additional files
521 f=${QTHEADERDIR}
522 h=${QTLIBDIR}
523 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
524 f=${f#*/}
525 h=${h#*/}
526 done
527 rdir=${h}
528 f="../"
529 while [[ ${h} == */* ]] ; do
530 f="${f}../"
531 h=${h#*/}
532 done
533 rdir="${f}${rdir}"
534
535 for frw in "${D}${QTLIBDIR}"/*.framework; do
536 [[ -e "${frw}"/Headers ]] || continue
537 f=$(basename ${frw})
538 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
539 dosym "${rdir}"/${f}/Headers "${dest}"
540
541 # Link normal headers as well.
542 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
543 h=$(basename ${hdr})
544 dosym "../${rdir}"/${f}/Headers/${h} \
545 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
546 done
547 done
548 fi
549}
550
551# @FUNCTION: qt4-build_src_install
552# @DESCRIPTION:
553# Perform the actual installation including some library fixes.
554qt4-build_src_install() {
555 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
556 setqtenv
557
558 install_directories ${QT4_TARGET_DIRECTORIES}
559 install_qconfigs
560 fix_library_files
561 fix_includes
562
563 # remove .la files since we are building only shared Qt libraries
564 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
565}
566
567# @FUNCTION: setqtenv
568# @INTERNAL
569setqtenv() {
570 # Set up installation directories
571 QTPREFIXDIR=${EPREFIX}/usr
572 QTBINDIR=${EPREFIX}/usr/bin
573 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
574 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
575 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
576 QTHEADERDIR=${EPREFIX}/usr/include/qt4
577 QTPLUGINDIR=${QTLIBDIR}/plugins
578 QTIMPORTDIR=${QTLIBDIR}/imports
579 QTDATADIR=${EPREFIX}/usr/share/qt4
580 QTTRANSDIR=${QTDATADIR}/translations
581 QTSYSCONFDIR=${EPREFIX}/etc/qt4
582 QTEXAMPLESDIR=${QTDATADIR}/examples
583 QTDEMOSDIR=${QTDATADIR}/demos
584 QMAKE_LIBDIR_QT=${QTLIBDIR}
585 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
586
587 PLATFORM=$(qt_mkspecs_dir)
588 unset QMAKESPEC
589
590 export XDG_CONFIG_HOME="${T}"
591}
592
593# @FUNCTION: prepare_directories
594# @USAGE: < directories >
595# @INTERNAL
596# @DESCRIPTION:
597# Generates Makefiles for the given list of directories.
598prepare_directories() {
599 for x in "$@"; do
600 pushd "${S}"/${x} >/dev/null || die
601 einfo "Running qmake in: ${x}"
602 # avoid running over the maximum argument number, bug #299810
603 {
604 echo "${S}"/mkspecs/common/*.conf
605 find "${S}" -name '*.pr[io]'
606 } | xargs sed -i \
607 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
608 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
609 || die
610 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
611 popd >/dev/null || die
612 done
613}
614
366 615
367# @FUNCTION: build_directories 616# @FUNCTION: build_directories
368# @USAGE: < directories > 617# @USAGE: < directories >
618# @INTERNAL
369# @DESCRIPTION: 619# @DESCRIPTION:
370# Compiles the code in $QT4_TARGET_DIRECTORIES 620# Compiles the code in the given list of directories.
371build_directories() { 621build_directories() {
372 local dirs="$@"
373 for x in ${dirs}; do 622 for x in "$@"; do
374 cd "${S}"/${x} 623 pushd "${S}"/${x} >/dev/null || die
375 sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:/usr/$(get_libdir)/qt4:g" $(find "${S}" -name '*.pr[io]') "${S}"/mkspecs/common/linux.conf || die 624 emake CC="$(tc-getCC)" \
376 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 625 CXX="$(tc-getCXX)" \
377 emake CC="@echo compiling \$< && $(tc-getCC)" \
378 CXX="@echo compiling \$< && $(tc-getCXX)" \
379 LINK="@echo linking \$@ && $(tc-getCXX)" || die "emake failed" 626 LINK="$(tc-getCXX)" || die "emake failed"
627 popd >/dev/null || die
380 done 628 done
381} 629}
382 630
383# @FUNCTION: install_directories 631# @FUNCTION: install_directories
384# @USAGE: < directories > 632# @USAGE: < directories >
633# @INTERNAL
385# @DESCRIPTION: 634# @DESCRIPTION:
386# run emake install in the given directories, which are separated by spaces 635# Runs emake install in the given directories, which are separated by spaces.
387install_directories() { 636install_directories() {
388 local dirs="$@"
389 for x in ${dirs}; do 637 for x in "$@"; do
390 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 638 pushd "${S}"/${x} >/dev/null || die
391 emake INSTALL_ROOT="${D}" install || die "emake install failed" 639 emake INSTALL_ROOT="${D}" install || die "emake install failed"
392 popd >/dev/null || die "Can't popd from ${S}/${x}" 640 popd >/dev/null || die
393 done 641 done
394} 642}
395 643
396# @ECLASS-VARIABLE: QCONFIG_ADD 644# @ECLASS-VARIABLE: QCONFIG_ADD
397# @DESCRIPTION: 645# @DESCRIPTION:
398# List options that need to be added to QT_CONFIG in qconfig.pri 646# List options that need to be added to QT_CONFIG in qconfig.pri
399QCONFIG_ADD="${QCONFIG_ADD:-}" 647: ${QCONFIG_ADD:=}
400 648
401# @ECLASS-VARIABLE: QCONFIG_REMOVE 649# @ECLASS-VARIABLE: QCONFIG_REMOVE
402# @DESCRIPTION: 650# @DESCRIPTION:
403# List options that need to be removed from QT_CONFIG in qconfig.pri 651# List options that need to be removed from QT_CONFIG in qconfig.pri
404QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 652: ${QCONFIG_REMOVE:=}
405 653
406# @ECLASS-VARIABLE: QCONFIG_DEFINE 654# @ECLASS-VARIABLE: QCONFIG_DEFINE
407# @DESCRIPTION: 655# @DESCRIPTION:
408# List variables that should be defined at the top of QtCore/qconfig.h 656# List variables that should be defined at the top of QtCore/qconfig.h
409QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 657: ${QCONFIG_DEFINE:=}
410 658
411# @FUNCTION: install_qconfigs 659# @FUNCTION: install_qconfigs
660# @INTERNAL
661# @DESCRIPTION:
412# @DESCRIPTION: Install gentoo-specific mkspecs configurations 662# Install gentoo-specific mkspecs configurations.
413install_qconfigs() { 663install_qconfigs() {
414 local x 664 local x
415 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 665 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
416 for x in QCONFIG_ADD QCONFIG_REMOVE; do 666 for x in QCONFIG_ADD QCONFIG_REMOVE; do
417 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 667 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
418 done 668 done
419 insinto ${QTDATADIR}/mkspecs/gentoo 669 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
420 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 670 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
421 fi 671 fi
422 672
423 if [[ -n ${QCONFIG_DEFINE} ]]; then 673 if [[ -n ${QCONFIG_DEFINE} ]]; then
424 for x in ${QCONFIG_DEFINE}; do 674 for x in ${QCONFIG_DEFINE}; do
425 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 675 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
426 done 676 done
427 insinto ${QTHEADERDIR}/Gentoo 677 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
428 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 678 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
429 fi 679 fi
430} 680}
431 681
432# @FUNCTION: generate_qconfigs 682# @FUNCTION: generate_qconfigs
433# @DESCRIPTION: Generates gentoo-specific configurations 683# @INTERNAL
684# @DESCRIPTION:
685# Generates gentoo-specific qconfig.{h,pri}.
434generate_qconfigs() { 686generate_qconfigs() {
435 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 687 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
436 local x qconfig_add qconfig_remove qconfig_new 688 local x qconfig_add qconfig_remove qconfig_new
437 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 689 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
438 [[ -f ${x} ]] || continue 690 [[ -f ${x} ]] || continue
439 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 691 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
440 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 692 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
441 done 693 done
442 694
443 # these error checks do not use die because dying in pkg_post{inst,rm} 695 # these error checks do not use die because dying in pkg_post{inst,rm}
444 # just makes things worse. 696 # just makes things worse.
445 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 697 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
452 704
453 # generate list of QT_CONFIG entries from the existing list 705 # generate list of QT_CONFIG entries from the existing list
454 # including qconfig_add and excluding qconfig_remove 706 # including qconfig_add and excluding qconfig_remove
455 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 707 for x in $(sed -n 's/^QT_CONFIG +=//p' \
456 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 708 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
457 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 709 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
458 done 710 done
459 711
460 # replace the existing QT_CONFIG list with qconfig_new 712 # replace the existing QT_CONFIG list with qconfig_new
461 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 713 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
462 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 714 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
486 fi 738 fi
487 fi 739 fi
488} 740}
489 741
490# @FUNCTION: qt4-build_pkg_postrm 742# @FUNCTION: qt4-build_pkg_postrm
743# @DESCRIPTION:
491# @DESCRIPTION: Generate configurations when the package is completely removed 744# Regenerate configuration when the package is completely removed.
492qt4-build_pkg_postrm() { 745qt4-build_pkg_postrm() {
493 generate_qconfigs 746 generate_qconfigs
494} 747}
495 748
496# @FUNCTION: qt4-build_pkg_postinst 749# @FUNCTION: qt4-build_pkg_postinst
750# @DESCRIPTION:
497# @DESCRIPTION: Generate configuration, plus throws a message about possible 751# Regenerate configuration, plus throw a message about possible
498# breakages and proposed solutions. 752# breakages and proposed solutions.
499qt4-build_pkg_postinst() { 753qt4-build_pkg_postinst() {
500 generate_qconfigs 754 generate_qconfigs
501
502 if [[ "${PN}" == "qt-core" ]]; then
503 echo
504 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
505 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
506 ewarn "should recompile the packages providing these plugins. Also, make sure you"
507 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
508 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
509 ewarn
510 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
511 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
512 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
513 ewarn "configuration."
514 ewarn
515 ewarn "For more information, see http://doc.trolltech.com/${PV%.*}/plugins-howto.html"
516 echo
517 fi
518} 755}
519 756
520# @FUNCTION: skip_qmake_build_patch 757# @FUNCTION: skip_qmake_build
758# @INTERNAL
521# @DESCRIPTION: 759# @DESCRIPTION:
522# Don't need to build qmake, as it's already installed from qt-core 760# Patches configure to skip qmake compilation, as it's already installed by qt-core.
523skip_qmake_build_patch() { 761skip_qmake_build() {
524 # Don't need to build qmake, as it's already installed from qt-core
525 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 762 sed -i -e "s:if true:if false:g" "${S}"/configure || die
526} 763}
527 764
528# @FUNCTION: skip_project_generation_patch 765# @FUNCTION: skip_project_generation
766# @INTERNAL
529# @DESCRIPTION: 767# @DESCRIPTION:
530# Exit the script early by throwing in an exit before all of the .pro files are scanned 768# Exit the script early by throwing in an exit before all of the .pro files are scanned.
531skip_project_generation_patch() { 769skip_project_generation() {
532 # Exit the script early by throwing in an exit before all of the .pro files are scanned
533 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 770 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
534 -i "${S}"/configure || die "Sed failed"
535} 771}
536 772
537# @FUNCTION: symlink_binaries_to_buildtree 773# @FUNCTION: symlink_binaries_to_buildtree
774# @INTERNAL
538# @DESCRIPTION: 775# @DESCRIPTION:
539# Symlink generated binaries to buildtree so they can be used during compilation 776# Symlinks generated binaries to buildtree, so they can be used during compilation time.
540# time
541symlink_binaries_to_buildtree() { 777symlink_binaries_to_buildtree() {
542 for bin in qmake moc uic rcc; do 778 for bin in qmake moc uic rcc; do
543 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 779 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
544 done 780 done
545} 781}
546 782
547# @FUNCTION: fix_library_files 783# @FUNCTION: fix_library_files
784# @INTERNAL
548# @DESCRIPTION: 785# @DESCRIPTION:
549# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 786# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
550# moves the *.pc-files into the pkgconfig directory 787# moves the *.pc files into the pkgconfig directory.
551fix_library_files() { 788fix_library_files() {
789 local libfile
552 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 790 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
553 if [[ -e ${libfile} ]]; then 791 if [[ -e ${libfile} ]]; then
554 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 792 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
555 fi 793 fi
556 done 794 done
557 795
558 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 796 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
559 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 797 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
560 if [[ -e ${libfile} ]]; then 798 if [[ -e ${libfile} ]]; then
561 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 799 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
562 800
563 # Move .pc files into the pkgconfig directory 801 # Move .pc files into the pkgconfig directory
564 dodir ${QTPCDIR} 802 dodir ${QTPCDIR#${EPREFIX}}
565 mv ${libfile} "${D}"/${QTPCDIR}/ \ 803 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
566 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
567 fi 804 fi
568 done 805 done
569 806
570 # Don't install an empty directory 807 # Don't install an empty directory
571 rmdir "${D}"/${QTLIBDIR}/pkgconfig 808 rmdir "${D}"/${QTLIBDIR}/pkgconfig
572} 809}
573 810
574# @FUNCTION: qt_use 811# @FUNCTION: qt_use
575# @USAGE: < flag > [ feature ] [ enableval ] 812# @USAGE: < flag > [ feature ] [ enableval ]
576# @DESCRIPTION: 813# @DESCRIPTION:
577# This will echo "${enableval}-${feature}" if <flag> is enabled, or 814# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
578# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 815# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
579# will be used for that. If [enableval] is not specified, it omits the 816# will be used for that. If [enableval] is not specified, it omits the
580# assignment-part 817# "-${enableval}" part.
581qt_use() { 818qt_use() {
582 local flag="${1}" 819 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
583 local feature="${1}"
584 local enableval=
585
586 [[ -n ${2} ]] && feature=${2}
587 [[ -n ${3} ]] && enableval="-${3}"
588
589 if use ${flag}; then
590 echo "${enableval}-${feature}"
591 else
592 echo "-no-${feature}"
593 fi
594}
595
596# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK
597# @DESCRIPTION:
598# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use
599# (eutils.eclass), line per line.
600#
601# Example:
602# @CODE
603# pkg_setup() {
604# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
605# ~x11-libs/qt-gui-${PV} qt3support"
606# qt4-build_check_use
607# }
608# @CODE
609
610# Run built_with_use on each flag and print appropriate error messages if any
611# flags are missing
612
613_qt_built_with_use() {
614 local missing opt pkg flag flags
615
616 if [[ ${1} = "--missing" ]]; then
617 missing="${1} ${2}" && shift 2
618 fi
619 if [[ ${1:0:1} = "-" ]]; then
620 opt=${1} && shift
621 fi
622
623 pkg=${1} && shift
624
625 for flag in "${@}"; do
626 flags="${flags} ${flag}"
627 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
628 flags="${flags}*"
629 else
630 [[ ${opt} = "-o" ]] && return 0
631 fi
632 done
633 if [[ "${flags# }" = "${@}" ]]; then
634 return 0
635 fi
636 if [[ ${opt} = "-o" ]]; then
637 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
638 else
639 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
640 fi
641 return 1
642}
643
644# @FUNCTION: qt4-build_check_use
645# @DESCRIPTION:
646# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
647# USE flags listed.
648#
649# If any of the required USE flags are missing, an eerror will be printed for
650# each package with missing USE flags.
651qt4-build_check_use() {
652 local line missing
653 while read line; do
654 [[ -z ${line} ]] && continue
655 if ! _qt_built_with_use ${line}; then
656 missing=true
657 fi
658 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
659 if [[ -n ${missing} ]]; then
660 echo
661 eerror "Flags marked with an * are missing."
662 die "Missing USE flags found"
663 fi
664} 820}
665 821
666# @FUNCTION: qt_mkspecs_dir 822# @FUNCTION: qt_mkspecs_dir
667# @RETURN: the specs-directory w/o path 823# @RETURN: the specs-directory w/o path
668# @DESCRIPTION: 824# @DESCRIPTION:
669# Allows us to define which mkspecs dir we want to use. 825# Allows us to define which mkspecs dir we want to use.
670qt_mkspecs_dir() { 826qt_mkspecs_dir() {
671 # Allows us to define which mkspecs dir we want to use.
672 local spec 827 local spec=
673 828
674 case ${CHOST} in 829 case "${CHOST}" in
675 *-freebsd*|*-dragonfly*) 830 *-freebsd*|*-dragonfly*)
676 spec="freebsd" ;; 831 spec=freebsd ;;
677 *-openbsd*) 832 *-openbsd*)
678 spec="openbsd" ;; 833 spec=openbsd ;;
679 *-netbsd*) 834 *-netbsd*)
680 spec="netbsd" ;; 835 spec=netbsd ;;
681 *-darwin*) 836 *-darwin*)
837 if use aqua; then
838 # mac with carbon/cocoa
839 spec=macx
840 else
841 # darwin/mac with x11
682 spec="darwin" ;; 842 spec=darwin
843 fi
844 ;;
845 *-solaris*)
846 spec=solaris ;;
683 *-linux-*|*-linux) 847 *-linux-*|*-linux)
684 spec="linux" ;; 848 spec=linux ;;
685 *) 849 *)
686 die "Unknown CHOST, no platform choosen." 850 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
687 esac 851 esac
688 852
689 CXX=$(tc-getCXX) 853 case "$(tc-getCXX)" in
690 if [[ ${CXX/g++/} != ${CXX} ]]; then 854 *g++*)
691 spec="${spec}-g++" 855 spec+=-g++ ;;
692 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 856 *icpc*)
693 spec="${spec}-icc" 857 spec+=-icc ;;
694 else 858 *)
695 die "Unknown compiler ${CXX}." 859 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
696 fi 860 esac
697 if [[ -n "${LIBDIR/lib}" ]]; then 861
698 spec="${spec}-${LIBDIR/lib}" 862 # Add -64 for 64bit profiles
863 if use x64-freebsd ||
864 use amd64-linux ||
865 use x64-macos ||
866 use x64-solaris ||
867 use sparc64-solaris
868 then
869 spec+=-64
699 fi 870 fi
700 871
701 echo "${spec}" 872 echo "${spec}"
702} 873}
703 874
704case ${EAPI:-0} in 875# @FUNCTION: qt_assistant_cleanup
705 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 876# @INTERNAL
877# @DESCRIPTION:
878# Tries to clean up tools.pro for qt-assistant ebuilds.
879# Meant to be called in src_prepare().
880# Since Qt 4.7.4 this function is a no-op.
881qt_assistant_cleanup() {
882 # apply patching to qt-assistant ebuilds only
883 [[ ${PN} != qt-assistant ]] && return
884
885 # no longer needed for 4.7.4 and later
886 version_is_at_least 4.7.4 && return
887
888 # different versions (and branches...) may need different handling,
889 # add a case if you need special handling
890 case "${MY_PV_EXTRA}" in
891 *kde-qt*)
892 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
893 -e "/mac/,/^embedded.*makeqpf$/d" \
894 -i tools/tools.pro || die "patching tools.pro failed"
895 ;;
896 *)
897 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
898 -e "/mac/,/^embedded.*makeqpf$/d" \
899 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
900 -i tools/tools.pro || die "patching tools.pro failed"
901 ;;
902 esac
903}
904
905# @FUNCTION: qt_nolibx11
906# @INTERNAL
907# @DESCRIPTION:
908# Ignore X11 tests for packages that don't need X libraries installed.
909qt_nolibx11() {
910 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
911 die "x11 check sed failed"
912}
913
706 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 914EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
707esac

Legend:
Removed from v.1.54  
changed lines
  Added in v.1.132

  ViewVC Help
Powered by ViewVC 1.1.20